#include<bits/stdc++.h>
using namespace std;
int br[10000001];
vector<pair<int, int>> v;
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m=0;
    cin>>n;
    for(int i=0;i<n;i++){
        int a, b;
        cin>>a>>b;
        m=max(m, b);
        v.push_back({a, b});
        for(int j=a;j<b;j++){
            br[j]++;
        }
    }
    int ans=0, index, broj=1;
    for(int i=0;i<m;i++){
        if(br[i]==ans) broj++;
        if(br[i]>ans){
            index=i;
            ans=br[i];
            broj=1;
        }
    }
    cout<<ans<<endl<<broj;
    return 0;
}
